const WebSocket = require('ws')
const osc = require('osc')

const ip = process.argv[2]

const DEBUG = {
  osc: true
}

const oscWS = new osc.WebSocketPort({
  url: `ws://${ip}:6676`,
  metadata: false
})

const bwPortUkazi = 8000
const bwPortStanje = 9000
const bwIP = '192.168.64.113'

const oscWSstanje = new osc.UDPPort({
  localAddress: bwIP,
  localPort: bwPortStanje,
  metadata: false
})

const oscWSukazi = new osc.UDPPort({
  localAddress: bwIP,
  localPort: bwPortUkazi,
  metadata: false
})

oscWS.on('ready', () => {
  console.log(`Povezan sem na ${ip}`)

  /*
  setInterval(() => {
    console.log('ping')
    oscWS.send({ address: '/ping', args: [true]})
  }, 500)
  */
})

oscWSstanje.on('ready', () => {
  console.log(`Prejemam bitwig info`)
})

oscWSukazi.on('ready', () => {
  console.log(`Pripravljen sem na posiljanje v bitwig`)
})

oscWS.on('message', ({ address, args }) => {
  DEBUG.osc && console.log('MSG OSC', address, args.map(x => x.toFixed(4)))

  // Wavey Wind sporočila
  const re = /\/ww\/(\d+)\/([a-zA-Z]+)/
  const m = address.match(re)

  if (m) {
    /*
    oscWS.send({
      address: '/midi',
      args: [midiKanal, visina, 127]
    })
    */
  }
})
 
oscWSstanje.on('message', ({ address, args }) => {
  DEBUG.osc && console.log('BITWIG OSC', address, args.map(x => x.toFixed(4)))
})

oscWS.open()
//oscWSstanje.open()
oscWSukazi.open()
